<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates/framework/sel4/src/object.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>object.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../sel4/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../sel4/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../sel4/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::sys</span>;

<span class="kw">type</span> <span class="ident">RawObjectType</span> <span class="op">=</span> <span class="ident">u32</span>;

<span class="attribute">#[<span class="ident">repr</span>(<span class="ident">u32</span>)]</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Copy</span>, <span class="ident">Clone</span>, <span class="ident">Debug</span>, <span class="ident">Eq</span>, <span class="ident">PartialEq</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">ObjectType</span> {
    <span class="ident">Untyped</span> <span class="op">=</span> <span class="ident">sys::api_object_seL4_UntypedObject</span>,
    <span class="ident">Endpoint</span> <span class="op">=</span> <span class="ident">sys::api_object_seL4_EndpointObject</span>,
    <span class="ident">Notification</span> <span class="op">=</span> <span class="ident">sys::api_object_seL4_NotificationObject</span>,
    <span class="ident">CNode</span> <span class="op">=</span> <span class="ident">sys::api_object_seL4_CapTableObject</span>,
    <span class="ident">TCB</span> <span class="op">=</span> <span class="ident">sys::api_object_seL4_TCBObject</span>,
    <span class="ident">VCPU</span> <span class="op">=</span> <span class="ident">sys::_object_seL4_ARM_VCPUObject</span>,
    <span class="ident">SmallPage</span> <span class="op">=</span> <span class="ident">sys::_object_seL4_ARM_SmallPageObject</span>,
    <span class="ident">LargePage</span> <span class="op">=</span> <span class="ident">sys::_object_seL4_ARM_LargePageObject</span>,
    <span class="ident">HugePage</span> <span class="op">=</span> <span class="ident">sys::_mode_object_seL4_ARM_HugePageObject</span>,
    <span class="ident">PT</span> <span class="op">=</span> <span class="ident">sys::_object_seL4_ARM_PageTableObject</span>,
    <span class="ident">PD</span> <span class="op">=</span> <span class="ident">sys::_object_seL4_ARM_PageDirectoryObject</span>,
    <span class="ident">PUD</span> <span class="op">=</span> <span class="ident">sys::_mode_object_seL4_ARM_PageUpperDirectoryObject</span>,
    <span class="ident">PGD</span> <span class="op">=</span> <span class="ident">sys::_mode_object_seL4_ARM_PageGlobalDirectoryObject</span>,
}

<span class="kw">impl</span> <span class="ident">ObjectType</span> {
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">raw</span>(<span class="self">self</span>) -&gt; <span class="ident">RawObjectType</span> {
        <span class="self">self</span> <span class="kw">as</span> <span class="ident">RawObjectType</span>
    }
}

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Copy</span>, <span class="ident">Clone</span>, <span class="ident">Debug</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">PartialOrd</span>, <span class="ident">Ord</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">ObjectBlueprint</span> {
    <span class="ident">Untyped</span> { <span class="ident">size_bits</span>: <span class="ident">usize</span> },
    <span class="ident">Endpoint</span>,
    <span class="ident">Notification</span>,
    <span class="ident">CNode</span> { <span class="ident">size_bits</span>: <span class="ident">usize</span> },
    <span class="ident">TCB</span>,
    <span class="ident">VCPU</span>,
    <span class="ident">SmallPage</span>,
    <span class="ident">LargePage</span>,
    <span class="ident">HugePage</span>,
    <span class="ident">PT</span>,
    <span class="ident">PD</span>,
    <span class="ident">PUD</span>,
    <span class="ident">PGD</span>,
}

<span class="kw">impl</span> <span class="ident">ObjectBlueprint</span> {
    <span class="kw">pub</span> <span class="kw">const</span> <span class="kw">fn</span> <span class="ident">ty</span>(<span class="self">self</span>) -&gt; <span class="ident">ObjectType</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident"><span class="self">Self</span>::Untyped</span> { .. } =&gt; <span class="ident">ObjectType::Untyped</span>,
            <span class="ident"><span class="self">Self</span>::Endpoint</span> =&gt; <span class="ident">ObjectType::Endpoint</span>,
            <span class="ident"><span class="self">Self</span>::Notification</span> =&gt; <span class="ident">ObjectType::Notification</span>,
            <span class="ident"><span class="self">Self</span>::CNode</span> { .. } =&gt; <span class="ident">ObjectType::CNode</span>,
            <span class="ident"><span class="self">Self</span>::TCB</span> =&gt; <span class="ident">ObjectType::TCB</span>,
            <span class="ident"><span class="self">Self</span>::VCPU</span> =&gt; <span class="ident">ObjectType::VCPU</span>,
            <span class="ident"><span class="self">Self</span>::SmallPage</span> =&gt; <span class="ident">ObjectType::SmallPage</span>,
            <span class="ident"><span class="self">Self</span>::LargePage</span> =&gt; <span class="ident">ObjectType::LargePage</span>,
            <span class="ident"><span class="self">Self</span>::HugePage</span> =&gt; <span class="ident">ObjectType::HugePage</span>,
            <span class="ident"><span class="self">Self</span>::PT</span> =&gt; <span class="ident">ObjectType::PT</span>,
            <span class="ident"><span class="self">Self</span>::PD</span> =&gt; <span class="ident">ObjectType::PD</span>,
            <span class="ident"><span class="self">Self</span>::PUD</span> =&gt; <span class="ident">ObjectType::PUD</span>,
            <span class="ident"><span class="self">Self</span>::PGD</span> =&gt; <span class="ident">ObjectType::PGD</span>,
        }
    }

    <span class="kw">pub</span> <span class="kw">const</span> <span class="kw">fn</span> <span class="ident">raw_size_bits</span>(<span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident"><span class="self">Self</span>::Untyped</span> { <span class="ident">size_bits</span> } =&gt; <span class="prelude-val">Some</span>(<span class="ident">size_bits</span>),
            <span class="ident"><span class="self">Self</span>::CNode</span> { <span class="ident">size_bits</span> } =&gt; <span class="prelude-val">Some</span>(<span class="ident">size_bits</span>),
            <span class="kw">_</span> =&gt; <span class="prelude-val">None</span>,
        }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">physical_size_bits</span>(<span class="self">self</span>) -&gt; <span class="ident">usize</span> {
        (<span class="kw">match</span> <span class="self">self</span> {
            <span class="ident"><span class="self">Self</span>::Untyped</span> { <span class="ident">size_bits</span> } =&gt; <span class="ident">u32::try_from</span>(<span class="ident">size_bits</span>).<span class="ident">unwrap</span>(),
            <span class="ident"><span class="self">Self</span>::Endpoint</span> =&gt; <span class="ident">sys::seL4_EndpointBits</span>,
            <span class="ident"><span class="self">Self</span>::Notification</span> =&gt; <span class="ident">sys::seL4_NotificationBits</span>,
            <span class="ident"><span class="self">Self</span>::CNode</span> { <span class="ident">size_bits</span> } =&gt; <span class="ident">sys::seL4_SlotBits</span> <span class="op">+</span> <span class="ident">u32::try_from</span>(<span class="ident">size_bits</span>).<span class="ident">unwrap</span>(),
            <span class="ident"><span class="self">Self</span>::TCB</span> =&gt; <span class="ident">sys::seL4_TCBBits</span>,
            <span class="ident"><span class="self">Self</span>::VCPU</span> =&gt; <span class="ident">sys::seL4_VCPUBits</span>,
            <span class="ident"><span class="self">Self</span>::SmallPage</span> =&gt; <span class="ident">sys::seL4_PageBits</span>,
            <span class="ident"><span class="self">Self</span>::LargePage</span> =&gt; <span class="ident">sys::seL4_LargePageBits</span>,
            <span class="ident"><span class="self">Self</span>::HugePage</span> =&gt; <span class="ident">sys::seL4_HugePageBits</span>,
            <span class="ident"><span class="self">Self</span>::PT</span> =&gt; <span class="ident">sys::seL4_PageTableBits</span>,
            <span class="ident"><span class="self">Self</span>::PD</span> =&gt; <span class="ident">sys::seL4_PageDirBits</span>,
            <span class="ident"><span class="self">Self</span>::PUD</span> =&gt; <span class="ident">sys::seL4_PUDBits</span>,
            <span class="ident"><span class="self">Self</span>::PGD</span> =&gt; <span class="ident">sys::seL4_PGDBits</span>,
        })
        .<span class="ident">try_into</span>()
        .<span class="ident">unwrap</span>()
    }

    <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">ASID_POOL_BITS</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="ident">sys::seL4_ASIDPoolBits</span>;

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">asid_pool</span>() -&gt; <span class="self">Self</span> {
        <span class="ident"><span class="self">Self</span>::Untyped</span> {
            <span class="ident">size_bits</span>: <span class="ident"><span class="self">Self</span>::ASID_POOL_BITS</span>.<span class="ident">try_into</span>().<span class="ident">unwrap</span>(),
        }
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="sel4" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>